VERSION 5.00
Begin VB.Form PlotFig1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Classification Plot"
   ClientHeight    =   8040
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   11850
   ClipControls    =   0   'False
   FillColor       =   &H00C0E0FF&
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   -1200
   ScaleLeft       =   -50
   ScaleMode       =   0  'User
   ScaleTop        =   1100
   ScaleWidth      =   1582.878
   StartUpPosition =   3  'Windows Default
   WhatsThisButton =   -1  'True
   WhatsThisHelp   =   -1  'True
   Begin VB.Frame Frame2 
      Caption         =   "Point Annotation"
      ClipControls    =   0   'False
      Height          =   1335
      Left            =   7440
      TabIndex        =   10
      Top             =   4320
      Width           =   1695
      Begin VB.OptionButton optAnn3 
         Caption         =   "Sample &ID"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   960
         Value           =   -1  'True
         Width           =   1455
      End
      Begin VB.OptionButton optAnn2 
         Caption         =   "Point &Number"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   600
         Width           =   1455
      End
      Begin VB.OptionButton optAnn1 
         Caption         =   "Point &Only"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   240
         Width           =   1455
      End
   End
   Begin VB.ListBox ListScrn 
      Height          =   3960
      Left            =   9480
      TabIndex        =   9
      Top             =   2400
      Visible         =   0   'False
      Width           =   2055
   End
   Begin VB.CommandButton PlotData 
      Caption         =   "Plot &Data Array"
      Height          =   375
      Left            =   7440
      TabIndex        =   8
      Top             =   480
      Width           =   1695
   End
   Begin VB.CommandButton SwitchScale 
      Caption         =   "S&how FINE Plot"
      Height          =   375
      Left            =   7440
      Style           =   1  'Graphical
      TabIndex        =   7
      Top             =   1680
      Width           =   1695
   End
   Begin VB.CommandButton Command4 
      Caption         =   "&Print Graphic"
      Height          =   375
      Left            =   7440
      TabIndex        =   3
      Top             =   2280
      Width           =   1695
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Create Random Data"
      Height          =   375
      Left            =   9480
      TabIndex        =   2
      Top             =   1800
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Clear Plot"
      Height          =   375
      Left            =   7440
      TabIndex        =   1
      Top             =   1080
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Run Plot Test"
      Height          =   375
      Left            =   9480
      TabIndex        =   0
      Top             =   1080
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.Frame Frame1 
      Caption         =   "Classification Method"
      ClipControls    =   0   'False
      Height          =   1215
      Left            =   7440
      TabIndex        =   4
      Top             =   2880
      Width           =   1695
      Begin VB.OptionButton OptFolk 
         Caption         =   "&Folk"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   720
         Width           =   1455
      End
      Begin VB.OptionButton OptShep 
         Caption         =   "&Sheppard"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   360
         Width           =   1455
      End
   End
End
Attribute VB_Name = "PlotFig1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Program SEDPLOT
'Title:  SEDPLOT
'A Visual Basic Program to Plot Sediment Distribution Based on Gravel-Sand-Silt-Clay Ratios
'using either the Shepard or Folk classification plotting method.
'Authors:
'L.J.Poppe, A.H.Eliason
'
'Development Language:  VB 6.0 Professional
'Minimum known working Environment:   Pentium II, 166Kbps,  MS Windows 98, 64 MB RAM
'

Dim Lable$(10)
Dim strInFile As String * 255
Dim strOutFile As String * 255
Dim strMethod As String * 4


'Dim singPData(4, 500) As Single


Public Sub Form_Load()
TestMode = False                'set true for program debug
intFlgs(6) = 3                  ' Set plot SID as default
If intFlgs(2) = 1 Then OptFolk.Value = True
If intFlgs(2) = 2 Then OptShep.Value = True

PlotFig1.Show
'Call Folk2
'MsgBox (" test ")
T1 = Timer                  'seconds past midnight
Do While Timer < T1 + 1
Loop
Frame1.ClipControls = False ' This allows repaint of the radiobutton objects
If TestMode Then
    Command1.Visible = True
    Command3.Visible = True
    ListScrn.Visible = True
End If
End Sub

    

Public Sub PrintText(frm As Form, Text As String, _
   X As Integer, Y As Integer)
   'X,Y are the starting print locations
   frm.ForeColor = vbBlack          'Color for the shadow
   frm.Font.Name = "Arial"
   frm.Font.Size = 12
   frm.CurrentX = X                 ' Positioning of the text, add numbers here
   frm.CurrentY = Y                 ' to make shadows
   frm.Print Text
   frm.ForeColor = vbGreen  'forecolor changed to green
   frm.CurrentX = X - 2
   frm.CurrentY = Y - 2
   frm.Print Text
   End Sub
Public Sub PrintText1(frm As Form, Text As String, _
   X As Integer, Y As Integer)
   'X,Y are the starting print locations
   'frm.ForeColor = vbBlack         'Color for the text
   frm.Font.Name = "Arial"
   frm.Font.Size = 12
   frm.CurrentX = X                 ' Positioning of the text, add numbers here
   frm.CurrentY = Y                 ' to make shadows
   frm.Print Text
   
   End Sub

Public Sub PrintText2(frm As Form, Text As String, _
   X As Integer, Y As Integer)
   'X,Y are the starting print locations
   frm.ForeColor = vbBlack         'Color for the text
   frm.Font.Name = "Arial"
   frm.Font.Size = 6
   frm.CurrentX = X                ' Positioning of the text
   frm.CurrentY = Y               '
   frm.Print Text
   
   End Sub
Private Sub PlotSpot(X As Integer, Y As Integer)
PSet (X + 0, Y + 0), vbBlack
PSet (X + 1, Y + 0), vbBlack
PSet (X - 1, Y + 0), vbBlack
PSet (X + 0, Y + 1), vbBlack
PSet (X + 0, Y - 1), vbBlack
End Sub

Private Sub PlotData_Click()    'Replot the Data Array
Index = singPData(0, 0)
For i = 1 To Index
    If intFlgs(6) < 2 Then TI$ = ""                         'Annotation = null
    If intFlgs(6) = 2 Then TI$ = Str(singPData(0, i))       'index count
    If intFlgs(6) = 3 Then TI$ = strSID(i)                  'Sample ID
    a = singPData(1, i)
    b = singPData(2, i)
    c = singPData(3, i)
    d = singPData(4, i)
    If intFlgs(2) = 1 Then Call PlotFolk(a, b, c, d, TI$)
    If intFlgs(2) = 2 Then Call PlotShep(a, b, c, d, TI$)
    
Next i
Command2.Visible = True
End Sub

Private Sub Command1_Click()    'Run

Call TestPlotShep
'Call Shep1
'Call Shep2
End Sub

Private Sub Command2_Click()    'Clear
PlotFig1.Cls
Call Replot
End Sub

Private Sub Command3_Click()    'Create & Plot Random Data
                                '200 points, half with gravel
Dim a, b, c, d, fac As Double
ListScrn.Clear
    singPData(0, 0) = 200       'store index
    For i = 1 To 200
      
         a = Rnd * 100
         b = Rnd * 100
         c = Rnd * 100
         d = Rnd * 100
         
         
        'If Rnd > 0.5 Then d = 0
        If i > 100 Then d = 0               ' use no Gravel
          T = (a + b + c + d)
          fac = 100 / T
          a = (a * fac)
          b = (b * fac)
          c = (c * fac)
          d = (d * fac)
          TI$ = Str$(i)
          singPData(0, i) = i
          singPData(1, i) = a
          singPData(2, i) = b
          singPData(3, i) = c
          singPData(4, i) = d
          TI$ = TI$ + Str$(Int(a)) + Str$(Int(b)) + Str$(Int(c)) + Str$(Int(d))
          ListScrn.AddItem TI$
          TI$ = Str$(i)
          If intFlgs(2) = 1 Then Call PlotFolk(a, b, c, d, TI$)
          If intFlgs(2) = 2 Then Call PlotShep(a, b, c, d, TI$)
    Next i
    Command2.Visible = True
End Sub

Public Sub Command4_Click()     'Print
                            ' form AutoRedraw must be on or just the objects plot!
Command1.Visible = False
Command3.Visible = False
ListScrn.Visible = False
PlotData.Visible = False
Command2.Visible = False
SwitchScale.Visible = False
Command4.Visible = False

PlotFig1.PrintForm

T1 = Timer                  'seconds past midnight
Do While Timer < T1 + 30
Loop
If TestMode = True Then
    Command1.Visible = True
    Command3.Visible = True
    ListScrn.Visible = True
End If
PlotData.Visible = True
Command2.Visible = True
SwitchScale.Visible = True
Command4.Visible = True


End Sub
Private Sub SwitchScale_Click()
If intFlgs(7) = 1 Then
    intFlgs(7) = 0
    SwitchScale.Caption = "S&how FINE Plot"
    If intFlgs(2) = 1 Then Call Folk2
    If intFlgs(2) = 2 Then Call Shep2
Else
    intFlgs(7) = 1
    SwitchScale.Caption = "S&how COARSE Plot"
    If intFlgs(2) = 1 Then Call Folk1
    If intFlgs(2) = 2 Then Call Shep1
End If
End Sub
Private Sub Replot()
If intFlgs(7) = 1 Then 'COARSE
    If intFlgs(2) = 1 Then Call Folk1
    If intFlgs(2) = 2 Then Call Shep1
Else                   'FINE
    If intFlgs(2) = 1 Then Call Folk2
    If intFlgs(2) = 2 Then Call Shep2
End If
If intFlgs(2) = 1 Then
    Frame1.BackColor = &H80000003
    OptFolk.BackColor = &H80FF80
    OptShep.BackColor = &H80000003
End If
If intFlgs(2) = 2 Then
    Frame1.BackColor = &H80000003
    OptFolk.BackColor = &H80000003
    OptShep.BackColor = &H80FF80
End If
End Sub
Private Sub optFolk_Click()
'PlotFig1.Cls
Frame1.BackColor = &H80000003
OptFolk.BackColor = &H80FF80
OptShep.BackColor = &H80000003
strMethod = "Folk"
intFlgs(2) = 1

    If intFlgs(7) = 1 Then Call Folk1 'COARSE
    If intFlgs(7) = 0 Then Call Folk2 'FINE

'If intFlgs(0) = 1 And intFlgs(1) = 1 And intFlgs(2) > 0 Then cmdRun.BackColor = &H80FFFF
End Sub

Private Sub optShep_Click()
'PlotFig1.Cls
Frame1.BackColor = &H80000003
OptShep.BackColor = &H80FF80
OptFolk.BackColor = &H80000003
strMethod = "Shep"
intFlgs(2) = 2

    If intFlgs(7) = 1 Then Call Shep1 'COARSE
    If intFlgs(7) = 0 Then Call Shep2 'FINE
'If intFlgs(0) = 1 And intFlgs(1) = 1 And intFlgs(2) > 0 Then cmdRun.BackColor = &H80FFFF
End Sub
Private Sub optAnn1_Click()
intFlgs(6) = 1
End Sub
Private Sub optAnn2_Click()
intFlgs(6) = 2
End Sub
Private Sub optAnn3_Click()
intFlgs(6) = 3
End Sub
Private Sub Folk1()
PlotFig1.Show
Cls
PrintText Me, "Folk Sand-Silt-Clay Plot", 380, -50

    
    
    Line (0, 0)-(1000, 0), vbBlue
    Line (0, 0)-(500, 1000), vbBlue
    Line (500, 1000)-(1000, 0), vbBlue
    Line (50, 100)-(950, 100), vbBlue
    Line (250, 500)-(750, 500), vbBlue
    Line (450, 900)-(550, 900), vbBlue
    Line (333, 0)-(485, 900), vbBlue
    Line (667, 0)-(515, 900), vbBlue
        
    PlotFig1.ForeColor = vbBlue
            
    PrintText1 Me, "SAND", 455, 940
    
    PrintText1 Me, "CLAYEY", 300, 600
    PrintText1 Me, "SAND", 310, 550
    
    PrintText1 Me, "MUDDY", 445, 600
    PrintText1 Me, "SAND", 460, 550
    
    PrintText1 Me, "SILTY", 600, 600
    PrintText1 Me, "SAND", 600, 550
    
    PrintText1 Me, "SANDY", 200, 300
    PrintText1 Me, "CLAY", 200, 250
    
    PrintText1 Me, "SANDY", 450, 300
    PrintText1 Me, "MUD", 460, 250
    
    PrintText1 Me, "SANDY", 675, 300
    PrintText1 Me, "SILT", 690, 250
    
    PrintText1 Me, "CLAY", 150, 80
    PrintText1 Me, "MUD", 460, 80
    PrintText1 Me, "SILT", 750, 80
    
    Call TStamp                 ' Time-Date Stamp
End Sub
Private Sub Folk2()
PlotFig1.Show
Cls
PrintText Me, "Folk Gravel >0.1% Plot", 360, -50

    
    
    Line (0, 0)-(1000, 0), vbBlue
    Line (0, 0)-(500, 1000), vbBlue
    Line (500, 1000)-(1000, 0), vbBlue
    Line (400, 800)-(600, 800), vbBlue
    Line (150, 300)-(850, 300), vbBlue
    Line (25, 50)-(975, 50), vbBlue
    Line (100, 0)-(120, 50), vbBlue
    Line (500, 800)-(500, 0), vbBlue
    Line (580, 800)-(900, 0), vbBlue
        
    PlotFig1.ForeColor = vbBlue
            
    PrintText1 Me, "GRAVEL", 440, 850
    
    PrintText1 Me, "MUDDY", 315, 600
    PrintText1 Me, "GRAVEL", 315, 550
        
    PrintText1 Me, "MUDDY", 530, 600
    PrintText1 Me, "SANDY", 530, 550
    PrintText1 Me, "GRAVEL", 530, 500
    
    PrintText1 Me, "-----SANDY", 730, 500
    PrintText1 Me, "GRAVEL", 800, 450
    
    PrintText1 Me, "GRAVELLY", 150, 250
    PrintText1 Me, "MUD", 150, 200
    
    PrintText1 Me, "GRAVELLY", 600, 250
    PrintText1 Me, "MUDDY", 600, 200
    PrintText1 Me, "SAND", 600, 150
    
    
    PrintText1 Me, "-----GRAVELY", 870, 200
    PrintText1 Me, "SAND", 945, 150
    
    PrintText1 Me, "'", 35, 10
    PrintText1 Me, "'-- SLIGHTLY GRAVELLY MUD", 35, -5
    PrintText1 Me, "'", 35, 25
    
    
    PrintText1 Me, "GRAVELLY SANDY MUD", 125, 40
    
    PrintText1 Me, "GRAVELLY MUDDY SAND", 505, 40
    
    PrintText1 Me, "------SLIGHTLY GRAVELY", 950, 40
    PrintText1 Me, "SAND", 1015, 0
    
    Call TStamp                 ' Time-Date Stamp
End Sub
Private Sub Shep1()
PlotFig1.Show
Cls
PrintText Me, "Shepard Sand-Silt-Clay Plot", 310, -50

    
    
    Line (0, 0)-(1000, 0), vbBlue
    Line (0, 0)-(500, 1000), vbBlue
    Line (500, 1000)-(1000, 0), vbBlue
    Line (500, 750)-(500, 600), vbBlue
    Line (500, 600)-(300, 200), vbBlue
    Line (300, 200)-(700, 200), vbBlue
    Line (700, 200)-(500, 600), vbBlue
    Line (300, 200)-(187, 125), vbBlue
    Line (813, 125)-(700, 200), vbBlue
    Line (125, 250)-(250, 0), vbBlue
    Line (750, 0)-(875, 250), vbBlue
    Line (375, 750)-(625, 750), vbBlue
    Line (250, 500)-(400, 400), vbBlue
    Line (600, 400)-(750, 500), vbBlue
    Line (500, 0)-(500, 200), vbBlue
    
    PlotFig1.ForeColor = vbBlue
            
    PrintText1 Me, "CLAY", 460, 850
    PrintText1 Me, "SANDY", 350, 600
    PrintText1 Me, "CLAY", 350, 550
    PrintText1 Me, "SILTY", 550, 600
    PrintText1 Me, "CLAY", 580, 550
    PrintText1 Me, "CLAYEY", 200, 350
    PrintText1 Me, "SAND", 200, 300
    PrintText1 Me, "CLAYEY", 700, 350
    PrintText1 Me, "SILT", 750, 300
    PrintText1 Me, "SAND", 455, 400
    PrintText1 Me, "SILT", 460, 350
    PrintText1 Me, "CLAY", 455, 300
    
    PrintText1 Me, "SAND", 100, 100
    PrintText1 Me, "SILT", 850, 100
    PrintText1 Me, "SILTY", 350, 150
    PrintText1 Me, "SAND", 350, 100
    PrintText1 Me, "SANDY", 550, 150
    PrintText1 Me, "SILT", 550, 100
    PrintText1 Me, "CLAY", 350, 550
    Call TStamp                 ' Time-Date Stamp
End Sub


Private Sub Shep2()
PlotFig1.Show
Cls
PrintText Me, "Shepard Gravel >10% Plot", 300, -50

    
    
    Line (0, 0)-(1000, 0), vbBlue
    Line (0, 0)-(500, 1000), vbBlue
    Line (500, 1000)-(1000, 0), vbBlue
    Line (250, 500)-(400, 400), vbBlue
    Line (400, 400)-(500, 600), vbBlue
    Line (500, 600)-(500, 750), vbBlue
    Line (500, 750)-(625, 750), vbBlue
    Line (50, 100)-(950, 100), vbBlue
    
    PlotFig1.ForeColor = vbBlue
            
    PrintText1 Me, "GRAVEL", 440, 850
    
    PrintText1 Me, "GRAVELLY SEDIMENT", 350, 300
    
    PrintText1 Me, "SAND, SILT, AND CLAY (GRAVEL< 10%)", 250, 75
    Call TStamp                 ' Time-Date Stamp
    
End Sub
Private Sub TStamp()
VER$ = "082406-2"    ' Version #
    a$ = Time$
    X = 50           ' Place left midrange
    Y = 500
    Call PlotStr(X, Y, a$)
    a$ = Date$
    Y = 550
    Call PlotStr(X, Y, a$)
    Y = 600
    Call PlotStr(X, Y, VER$)
    
End Sub
Private Sub TestPlotShep()          ' Plots Two Triangles Fine on left Coarse on Right
 Dim X As Integer, Y As Integer     ' Used for test only
    
    For d = 0 To 100                  'sim Gravel
      For c = 0 To 100                'sim Clay
        For b = 0 To 100              'sim Silt
          For a = 0 To 100            'sim Sand
            
             If a + b + c + d = 100 Then
             
                sc = c + b              '  AKA Mud
                xa = (100 - a)
                X = (sc + (xa - sc) / 2) * 10
                Y = d * 10
                PSet (X + 1100, Y), vbBlack        ' Plot coarse
                'Call PlotSpot(X + 1100, Y)
                If d < 10 Then         ' need to renormalize for fines plot
                    tp = a + b + c
                    fac = 100 / tp
                    an = fac * a
                    bn = fac * b
                    cn = fac * c         ' end normalize
                    xa = (100 - an)
                    X = (bn + (xa - bn) / 2) * 10
                    Y = cn * 10
                    PSet (X, Y), vbRed               ' Plot fine
                    'Call PlotSpot(X, Y)
                End If
            End If
            'For i = 1 To 100000: Next i
            'ShepFig1.ForeColor = &H8000000F
            'PrintText1 Me, Str$(a), 600, 900
            'PrintText1 Me, Str$(b), 700, 900
            'PrintText1 Me, Str$(c), 800, 900
            
         
          Next a
        Next b
      Next c
    Next d
    Command2.Visible = True
End Sub
Private Sub PlotShep(a, b, c, d, Ts$)
T = a + b + c + d                       'assumes a-b-c-d already normalized to = 100
'MsgBox (Str$(T) + " Shep")
    If a + b + c + d > 99 And a + b + c + d < 101 Then
             
                sc = c + b          ' Mud
                xa = (100 - a)
                X = (xa + (sc - xa) / 2) * 10
                Y = d * 10
                If intFlgs(7) = 0 Then                  ' Plot COARSE
                    If d > 0 Then Call PlotVal(X, Y, Ts$)
                Else                                    ' Plot FINES
                    If d <= 10 Then                     ' If Gravel =< 10%
                        an = a + d                      ' Add any Gravel to Sand
                        bn = b
                        cn = c
                        xa = (100 - an)
                        X = (bn + (xa - bn) / 2) * 10
                        Y = cn * 10
                        Call PlotVal(X, Y, Ts$)
                    End If
                    
                End If
    
    Else
    
        MsgBox "The Values" + Str$(T) + " did not total 100%. "
        
    End If
    
    
End Sub
Private Sub PlotFolk(a, b, c, d, Ts$)
T = a + b + c + d                       'assumes a-b-c-d already normalized to = 100
'MsgBox (Str$(T) + " Folk")
    If a + b + c + d > 99 And a + b + c + d < 101 Then
             
                sc = 100 - (c + b)        ' Mud
                xa = a                      ' Terms reversed
                X = (xa + (sc - xa) / 2) * 10
                Y = d * 10
                If intFlgs(7) = 0 Then                  ' Plot COARSE
                    If d > 0 Then Call PlotVal(X, Y, Ts$)
                Else                                    ' Plot FINES
                    If d = 0 Then
                        an = c          ' Silt
                        bn = b          ' clay
                        cn = a          ' Sand  (Sand & Clay Reversed from Shepard)
                        xa = (100 - an)
                        X = (bn + (xa - bn) / 2) * 10
                        Y = cn * 10
                        Call PlotVal(X, Y, Ts$)
                    End If
                    
                End If
    
    Else
    
        MsgBox "The Values" + Str$(T) + " did not total 100%. "
        
    End If
    
End Sub
Private Sub PlotShepTest(a, b, c, d, Ts$)
T = a + b + c + d                       'assumes a-b-c-d already normalized to = 100
'msgBox (Str$(T))
    If a + b + c + d > 99 And a + b + c + d < 101 Then
             
                sc = c + b          ' Mud
                xa = (100 - a)
                X = (sc + (xa - sc) / 2) * 10
                Y = d * 10
                If d > 0 Then                           ' Plot COARSE on right
                    'PSet (X + 1100, Y), vbBlack        ' Plot coarse
                    'Call PlotSpot(X + 1100, Y)
                    Call PlotVal(X + 1100, Y, Ts$)
                Else            'd =0  Then             ' Plot FINES on left
                        'tp = a + b + c
                        'fac = 100 / tp
                        an = a
                        bn = b
                        cn = c
                        xa = (100 - an)
                        X = (bn + (xa - bn) / 2) * 10
                        Y = cn * 10
                        'PSet (X, Y), vbRed               ' Plot fine
                        'Call PlotSpot(X, Y)
                        Call PlotVal(X, Y, Ts$)
                
                    
                End If
    
    Else
    
        MsgBox "The Values" + Str$(T) + " did not total 100%. "
        
    End If
    
    
End Sub


Public Sub PlotVal(X, Y, a$)
' A routine to plot a symbol at the designated coordinates  this one prints "+" + a string

PlotFig1.Font.Size = 8
PrintText2 Me, "+ " + a$, Int(X) - 4, Int(Y) + 12
End Sub
Public Sub PlotStr(X, Y, a$)
' A routine to plot a value at the designated coordinates  this one prints a string

PlotFig1.Font.Size = 8
PrintText2 Me, a$, Int(X) - 4, Int(Y) + 12
End Sub

